package henkan.dsl.ide

import com.google.inject.Guice
import com.google.inject.Injector
import com.pmeade.websocket.net.WebSocket
import com.pmeade.websocket.net.WebSocketServerSocket
import java.io.IOException
import java.io.InputStream
import java.io.OutputStream
import java.net.ServerSocket
import java.util.concurrent.ExecutorService
import java.util.concurrent.Executors
import java.util.concurrent.Future
import java.util.function.Function
import org.eclipse.lsp4j.jsonrpc.Launcher
import org.eclipse.lsp4j.jsonrpc.MessageConsumer
import org.eclipse.lsp4j.services.LanguageClient
import org.eclipse.xtext.ide.server.LanguageServerImpl
import org.eclipse.xtext.ide.server.ServerModule
import org.eclipse.xtext.util.internal.Log
import org.eclipse.lsp4j.jsonrpc.messages.Message

@Log class RunWebSocketServer {
	def static void main(String[] args) throws InterruptedException, IOException {
		var Injector injector = Guice.createInjector(new ServerModule())
		var ServerSocket serverSocket = new ServerSocket(4389)
		var WebSocketServerSocket webSocketServerSocket = new WebSocketServerSocket(serverSocket)
		LOG.info("server started")
		try {
			while (true) {
				var WebSocket webSocket = webSocketServerSocket.accept()
				val String connectionID = '''«webSocket.localPort»:«webSocket.localAddress»'''
				try {
					LOG.info('''New LanguageServerInstance''')
					var LanguageServerImpl languageServer = injector.getInstance(LanguageServerImpl)
					LOG.info('''«connectionID» connected''')
					var Function<MessageConsumer, MessageConsumer> wrapper = [ consumer |
						{
							return new MessageConsumer{
								
								override consume(Message message) {
									//LOG.info('''message:«message»''')
									consumer.consume(message);
								}
								
							}
						}
					]
					var Launcher<LanguageClient> launcher = createSocketLauncher(languageServer, LanguageClient,
						Executors.newCachedThreadPool(), wrapper, webSocket.getInputStream(),
						webSocket.getOutputStream())
						languageServer.connect(launcher.getRemoteProxy())
						var Future<?> future = launcher.startListening()
						while (!future.isDone()) {
							if (future.isDone()) {
								LOG.info('''«connectionID» closed''')
								webSocket.close()
								languageServer.shutdown()
							}
							Thread.sleep(100)
						}
					} catch (Exception e) {
						LOG.info("got exception",e)
					}

				}
			} finally {
				webSocketServerSocket.close()
			}
		}

		def static package <T> Launcher<T> createSocketLauncher(Object localService, Class<T> remoteInterface,
			ExecutorService executorService, Function<MessageConsumer, MessageConsumer> wrapper,
			InputStream inputStream, OutputStream outputStream) throws IOException {
			return Launcher.createIoLauncher(localService, remoteInterface, inputStream, outputStream, executorService,
				wrapper)
		}
	}
	