package henkan.dsl.ide;

import com.google.common.base.Objects;
import com.google.inject.Guice;
import com.google.inject.Inject;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.PrintStream;
import java.io.PrintWriter;
import java.sql.Timestamp;
import java.util.concurrent.Future;
import org.apache.log4j.Logger;
import org.eclipse.lsp4j.jsonrpc.Launcher;
import org.eclipse.lsp4j.services.LanguageClient;
import org.eclipse.xtext.ide.server.LanguageServerImpl;
import org.eclipse.xtext.ide.server.ServerModule;
import org.eclipse.xtext.util.internal.Log;
import org.eclipse.xtext.xbase.lib.Conversions;
import org.eclipse.xtext.xbase.lib.Exceptions;
import org.eclipse.xtext.xbase.lib.Functions.Function1;
import org.eclipse.xtext.xbase.lib.IterableExtensions;

@Log
@SuppressWarnings("all")
public class HDSLServerLauncher {
  private static boolean IS_DEBUG = false;
  
  public static void main(final String[] args) {
    final Function1<String, Boolean> _function = new Function1<String, Boolean>() {
      public Boolean apply(final String it) {
        return Boolean.valueOf(Objects.equal(it, "debug"));
      }
    };
    HDSLServerLauncher.IS_DEBUG = IterableExtensions.<String>exists(((Iterable<String>)Conversions.doWrapArray(args)), _function);
    final InputStream stdin = System.in;
    final PrintStream stdout = System.out;
    HDSLServerLauncher.redirectStandardStreams();
    ServerModule _serverModule = new ServerModule();
    final HDSLServerLauncher launcher = Guice.createInjector(_serverModule).<HDSLServerLauncher>getInstance(HDSLServerLauncher.class);
    launcher.start(stdin, stdout);
  }
  
  @Inject
  private LanguageServerImpl languageServer;
  
  public void start(final InputStream in, final OutputStream out) {
    try {
      System.err.println("Starting Xtext Language Server.");
      PrintWriter _printWriter = new PrintWriter(System.out, true);
      final Launcher<LanguageClient> launcher = Launcher.<LanguageClient>createLauncher(this.languageServer, LanguageClient.class, in, out, true, _printWriter);
      this.languageServer.connect(launcher.getRemoteProxy());
      final Future<?> future = launcher.startListening();
      System.err.println("started.");
      while ((!future.isDone())) {
        Thread.sleep(10000l);
      }
    } catch (Throwable _e) {
      throw Exceptions.sneakyThrow(_e);
    }
  }
  
  public static void redirectStandardStreams() {
    try {
      byte[] _newByteArrayOfSize = new byte[0];
      ByteArrayInputStream _byteArrayInputStream = new ByteArrayInputStream(_newByteArrayOfSize);
      System.setIn(_byteArrayInputStream);
      String _name = HDSLServerLauncher.class.getName();
      String _plus = (_name + "-");
      long _currentTimeMillis = System.currentTimeMillis();
      Timestamp _timestamp = new Timestamp(_currentTimeMillis);
      final String id = (_plus + _timestamp);
      if (HDSLServerLauncher.IS_DEBUG) {
        final FileOutputStream stdFileOut = new FileOutputStream((("out-" + id) + ".log"));
        PrintStream _printStream = new PrintStream(stdFileOut);
        System.setOut(_printStream);
        final FileOutputStream stdFileErr = new FileOutputStream((("error-" + id) + ".log"));
        PrintStream _printStream_1 = new PrintStream(stdFileErr);
        System.setErr(_printStream_1);
      } else {
        ByteArrayOutputStream _byteArrayOutputStream = new ByteArrayOutputStream();
        PrintStream _printStream_2 = new PrintStream(_byteArrayOutputStream);
        System.setOut(_printStream_2);
        ByteArrayOutputStream _byteArrayOutputStream_1 = new ByteArrayOutputStream();
        PrintStream _printStream_3 = new PrintStream(_byteArrayOutputStream_1);
        System.setErr(_printStream_3);
      }
    } catch (Throwable _e) {
      throw Exceptions.sneakyThrow(_e);
    }
  }
  
  private final static Logger LOG = Logger.getLogger(HDSLServerLauncher.class);
}
