package henkan.dsl.ide;

import com.google.inject.Guice;
import com.google.inject.Injector;
import com.pmeade.websocket.net.WebSocket;
import com.pmeade.websocket.net.WebSocketServerSocket;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.InetAddress;
import java.net.ServerSocket;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;
import java.util.function.Function;
import org.apache.log4j.Logger;
import org.eclipse.lsp4j.jsonrpc.Launcher;
import org.eclipse.lsp4j.jsonrpc.MessageConsumer;
import org.eclipse.lsp4j.jsonrpc.messages.Message;
import org.eclipse.lsp4j.services.LanguageClient;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.eclipse.xtext.ide.server.LanguageServerImpl;
import org.eclipse.xtext.ide.server.ServerModule;
import org.eclipse.xtext.util.internal.Log;
import org.eclipse.xtext.xbase.lib.Exceptions;

@Log
@SuppressWarnings("all")
public class RunWebSocketServer {
  public static void main(final String[] args) throws InterruptedException, IOException {
    ServerModule _serverModule = new ServerModule();
    Injector injector = Guice.createInjector(_serverModule);
    ServerSocket serverSocket = new ServerSocket(4389);
    WebSocketServerSocket webSocketServerSocket = new WebSocketServerSocket(serverSocket);
    RunWebSocketServer.LOG.info("server started");
    try {
      while (true) {
        {
          WebSocket webSocket = webSocketServerSocket.accept();
          StringConcatenation _builder = new StringConcatenation();
          int _localPort = webSocket.getLocalPort();
          _builder.append(_localPort);
          _builder.append(":");
          InetAddress _localAddress = webSocket.getLocalAddress();
          _builder.append(_localAddress);
          final String connectionID = _builder.toString();
          try {
            StringConcatenation _builder_1 = new StringConcatenation();
            _builder_1.append("New LanguageServerInstance");
            RunWebSocketServer.LOG.info(_builder_1);
            LanguageServerImpl languageServer = injector.<LanguageServerImpl>getInstance(LanguageServerImpl.class);
            StringConcatenation _builder_2 = new StringConcatenation();
            _builder_2.append(connectionID);
            _builder_2.append(" connected");
            RunWebSocketServer.LOG.info(_builder_2);
            final Function<MessageConsumer, MessageConsumer> _function = new Function<MessageConsumer, MessageConsumer>() {
              public MessageConsumer apply(final MessageConsumer consumer) {
                return new MessageConsumer() {
                  public void consume(final Message message) {
                    consumer.consume(message);
                  }
                };
              }
            };
            Function<MessageConsumer, MessageConsumer> wrapper = _function;
            Launcher<LanguageClient> launcher = RunWebSocketServer.<LanguageClient>createSocketLauncher(languageServer, LanguageClient.class, 
              Executors.newCachedThreadPool(), wrapper, webSocket.getInputStream(), 
              webSocket.getOutputStream());
            languageServer.connect(launcher.getRemoteProxy());
            Future<?> future = launcher.startListening();
            while ((!future.isDone())) {
              {
                boolean _isDone = future.isDone();
                if (_isDone) {
                  StringConcatenation _builder_3 = new StringConcatenation();
                  _builder_3.append(connectionID);
                  _builder_3.append(" closed");
                  RunWebSocketServer.LOG.info(_builder_3);
                  webSocket.close();
                  languageServer.shutdown();
                }
                Thread.sleep(100);
              }
            }
          } catch (final Throwable _t) {
            if (_t instanceof Exception) {
              final Exception e = (Exception)_t;
              RunWebSocketServer.LOG.info("got exception", e);
            } else {
              throw Exceptions.sneakyThrow(_t);
            }
          }
        }
      }
    } finally {
      webSocketServerSocket.close();
    }
  }
  
  static <T extends Object> Launcher<T> createSocketLauncher(final Object localService, final Class<T> remoteInterface, final ExecutorService executorService, final Function<MessageConsumer, MessageConsumer> wrapper, final InputStream inputStream, final OutputStream outputStream) throws IOException {
    return Launcher.<T>createIoLauncher(localService, remoteInterface, inputStream, outputStream, executorService, wrapper);
  }
  
  private final static Logger LOG = Logger.getLogger(RunWebSocketServer.class);
}
