package henkan.dsl;

import com.google.inject.spi.TypeListener
import com.google.inject.TypeLiteral
import com.google.inject.spi.TypeEncounter
import com.google.inject.spi.InjectionListener
import org.eclipse.xtext.resource.XtextResourceSet
import org.eclipse.xtext.util.internal.Log
import org.eclipse.xtext.resource.impl.ResourceDescriptionsProvider

@Log public class XtextResourceSetListener implements TypeListener {

	override <I> hear(TypeLiteral<I> type, TypeEncounter<I> encounter) {
		encounter.register(new InjectionListener {

			override afterInjection(Object injectee) {
				if (injectee instanceof XtextResourceSet) {
					LOG.info("encountered xtextresourceset");
					if (!injectee.loadOptions.containsKey(ResourceDescriptionsProvider.LIVE_SCOPE))
						injectee.addLoadOption(ResourceDescriptionsProvider.LIVE_SCOPE, true);
				}
			}

		})
	}

}
