package henkan.dsl.jvmmodel

import org.eclipse.xtext.xbase.compiler.XbaseCompiler
import org.eclipse.xtext.xbase.XExpression
import org.eclipse.xtext.xbase.compiler.output.ITreeAppendable
import henkan.dsl.hDsl.EmitExpression
import henkan.dsl.hDsl.ExpressionColumn
import org.eclipse.xtext.util.internal.Log

@Log class HenkanCompiler extends XbaseCompiler {

	override protected doInternalToJavaStatement(XExpression obj, ITreeAppendable a, boolean isReferenced) {

		if (obj instanceof EmitExpression) {
			LOG.info("compilation is in progress")
			val varName = a.declareSyntheticVariable(obj, "_row");

			a.newLine();
			a.append('''«HDslJvmModelInferrer.getOperator(obj).name»Row''').append(" ").append(varName).
				append(''' = new «HDslJvmModelInferrer.getOperator(obj).name»Row();''').newLine;

			for (c : obj.columns) {
				if (c instanceof ExpressionColumn) {
					c.xpr.internalToJavaStatement(a, true)
					a.append('''«varName».«c.name» = ''')
					c.xpr.internalToJavaExpression(a)
					a.append(";").newLine
				}
			}

			a.append('''collector.out(«varName»);''').newLine
		} else {
			super.doInternalToJavaStatement(obj, a, isReferenced)
		}
	}

	override protected internalCanCompileToJavaExpression(XExpression e, ITreeAppendable a) {

		if (e instanceof EmitExpression)
			return false
		else
			super.internalCanCompileToJavaExpression(e, a)
	}
}
