package henkan.dsl.repo

import java.lang.annotation.Retention
import java.lang.annotation.Target
import com.google.inject.BindingAnnotation
import java.lang.annotation.RetentionPolicy
import java.lang.annotation.ElementType
import javax.inject.Inject
import org.eclipse.xtext.util.internal.Log
import com.typesafe.config.ConfigFactory

@Log class HoconSourceTypeRepo implements SourceTypeRepo {

	@Inject
	@HoconURL
	var String config
	
	override load(int id) {
		LOG.info('''config path is «config» when id is «id»''')
		val sourceConfig=ConfigFactory.load(config).getObject('''sources.«id»''')
		sourceConfig.keySet.toList.map[
			new ColumnInfo(it,Class.forName(sourceConfig.get(it).unwrapped.toString))
		]
	}

	@Retention(RetentionPolicy.RUNTIME)
	@Target(#[ElementType.FIELD, ElementType.PARAMETER])
	@BindingAnnotation
	annotation HoconURL {}

}
