/*
 * generated by Xtext 2.11.0
 */
package henkan.dsl.validation

import henkan.dsl.hDsl.HDslPackage
import henkan.dsl.hDsl.HenkanFlowDescription
import henkan.dsl.hDsl.HenkanNodeDescription
import henkan.dsl.hDsl.OperatorDescription
import henkan.dsl.hDsl.SinkDescription
import henkan.dsl.hDsl.SourceDescription
import java.util.Set
import org.eclipse.xtext.validation.Check
import org.eclipse.xtext.util.internal.Log
import org.eclipse.xtext.xbase.XExpression
import henkan.dsl.hDsl.EmitExpression

/**
 * This class contains custom validation rules. 
 * 
 * See https://www.eclipse.org/Xtext/documentation/303_runtime_concepts.html#validation
 */
@Log class HDslValidator extends AbstractHDslValidator {
	//
	@Check
	def checkCycle(HenkanNodeDescription node) {
		if (node instanceof OperatorDescription)
			LOG.info("operatordescription going to validate")
		if (node instanceof SourceDescription)
			return // nothing to check
		val visitedEntities = newHashSet(node)

		var HenkanNodeDescription current = null
		current = getSource(node)
		while (!(current instanceof SourceDescription) && current !== null) {
			if (visitedEntities.contains(current)) {
				if (node instanceof OperatorDescription)
					error("cycle in hierarchy of node '" + current.name + "'",
						HDslPackage.eINSTANCE.operatorDescription_Source)
				else
					error("cycle in hierarchy of node '" + current.name + "'",
						HDslPackage.eINSTANCE.sinkDescription_Source)
				return
			}
			visitedEntities.add(current)
			current = getSource(current)
		}
	}

	protected def HenkanNodeDescription getSource(HenkanNodeDescription node) {
		if (node instanceof OperatorDescription)
			node.source
		else if (node instanceof SinkDescription)
			node.source
	}

	@Check
	def checkNames(HenkanNodeDescription node) {
		var flow = node.eContainer as HenkanFlowDescription
		val Set<String> names = newHashSet()
		for (HenkanNodeDescription desc : flow.descriptions) {
			if (names.contains(desc.name.toLowerCase)) {
				error("duplicate node name of node '" + desc.name + "'",
					HDslPackage.eINSTANCE.henkanNodeDescription_Name)
			}
			names.add(desc.name.toLowerCase)
		}
	}

	@Check
	def checkSource(HenkanNodeDescription node) {
		if (node instanceof SourceDescription)
			return // nothing to check
		var HenkanNodeDescription current = null
		current = if (node instanceof OperatorDescription)
			node.source
		else if (node instanceof SinkDescription)
			node.source
		if (current instanceof SinkDescription) {
			if (node instanceof OperatorDescription)
				error("typeless node for source of node '" + current.name + "'",
					HDslPackage.eINSTANCE.operatorDescription_Source)
			else
				error("typeless node for source of node '" + current.name + "'",
					HDslPackage.eINSTANCE.sinkDescription_Source)
		}
	}

	override  def isValueExpectedRecursive(XExpression expr) {
		return expr.eContainer instanceof EmitExpression || super.isValueExpectedRecursive(expr)
	}

}
