/**
 * generated by Xtext 2.11.0
 */
package henkan.dsl.jvmmodel;

import com.google.inject.Inject;
import henkan.dsl.hDsl.EmitExpression;
import henkan.dsl.hDsl.ExpressionColumn;
import henkan.dsl.hDsl.HenkanClosure;
import henkan.dsl.hDsl.OperatorDescription;
import henkan.dsl.hDsl.RegExColumn;
import henkan.dsl.hDsl.SourceDescription;
import henkan.dsl.lib.HenkanRow;
import henkan.dsl.lib.Tuple2;
import henkan.dsl.repo.ColumnInfo;
import henkan.dsl.repo.SourceTypeRepo;
import java.util.Arrays;
import java.util.Iterator;
import java.util.List;
import java.util.regex.Pattern;
import org.apache.flink.util.Collector;
import org.apache.log4j.Logger;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.eclipse.xtext.common.types.JvmDeclaredType;
import org.eclipse.xtext.common.types.JvmField;
import org.eclipse.xtext.common.types.JvmFormalParameter;
import org.eclipse.xtext.common.types.JvmGenericType;
import org.eclipse.xtext.common.types.JvmMember;
import org.eclipse.xtext.common.types.JvmOperation;
import org.eclipse.xtext.common.types.JvmTypeReference;
import org.eclipse.xtext.common.types.JvmVisibility;
import org.eclipse.xtext.common.types.TypesFactory;
import org.eclipse.xtext.util.internal.Log;
import org.eclipse.xtext.xbase.XAbstractFeatureCall;
import org.eclipse.xtext.xbase.XExpression;
import org.eclipse.xtext.xbase.jvmmodel.AbstractModelInferrer;
import org.eclipse.xtext.xbase.jvmmodel.IJvmDeclaredTypeAcceptor;
import org.eclipse.xtext.xbase.jvmmodel.JvmTypesBuilder;
import org.eclipse.xtext.xbase.lib.Extension;
import org.eclipse.xtext.xbase.lib.Functions.Function1;
import org.eclipse.xtext.xbase.lib.IterableExtensions;
import org.eclipse.xtext.xbase.lib.Procedures.Procedure1;

/**
 * <p>Infers a JVM model from the source model.</p>
 * 
 * <p>The JVM model should contain all elements that would appear in the Java code
 * which is generated from the source model. Other models link against the JVM model rather than the source model.</p>
 */
@Log
@SuppressWarnings("all")
public class HDslJvmModelInferrer extends AbstractModelInferrer {
  /**
   * convenience API to build and initialize JVM types and their members.
   */
  @Inject
  @Extension
  private JvmTypesBuilder _jvmTypesBuilder;
  
  @Inject
  private SourceTypeRepo repo;
  
  @Inject
  private TypesFactory typesFactory;
  
  /**
   * The dispatch method {@code infer} is called for each instance of the
   * given element's type that is contained in a resource.
   * 
   * @param element
   *            the model to create one or more
   *            {@link org.eclipse.xtext.common.types.JvmDeclaredType declared
   *            types} from.
   * @param acceptor
   *            each created
   *            {@link org.eclipse.xtext.common.types.JvmDeclaredType type}
   *            without a container should be passed to the acceptor in order
   *            get attached to the current resource. The acceptor's
   *            {@link IJvmDeclaredTypeAcceptor#accept(org.eclipse.xtext.common.types.JvmDeclaredType)
   *            accept(..)} method takes the constructed empty type for the
   *            pre-indexing phase. This one is further initialized in the
   *            indexing phase using the lambda you pass as the last argument.
   * @param isPreIndexingPhase
   *            whether the method is called in a pre-indexing phase, i.e.
   *            when the global index is not yet fully updated. You must not
   *            rely on linking using the index if isPreIndexingPhase is
   *            <code>true</code>.
   */
  protected void _infer(final HenkanClosure element, final IJvmDeclaredTypeAcceptor acceptor, final boolean isPreIndexingPhase) {
    final OperatorDescription operator = HDslJvmModelInferrer.getOperator(element);
    final String className = operator.getName();
    StringConcatenation _builder = new StringConcatenation();
    _builder.append(className);
    _builder.append("Function");
    final Procedure1<JvmGenericType> _function = new Procedure1<JvmGenericType>() {
      public void apply(final JvmGenericType it) {
        EList<JvmMember> _members = it.getMembers();
        final Procedure1<JvmOperation> _function = new Procedure1<JvmOperation>() {
          public void apply(final JvmOperation it) {
            EList<JvmFormalParameter> _parameters = it.getParameters();
            StringConcatenation _builder = new StringConcatenation();
            String _name = operator.getSource().getName();
            _builder.append(_name);
            _builder.append("Row");
            JvmFormalParameter _parameter = HDslJvmModelInferrer.this._jvmTypesBuilder.toParameter(element, "rows", HDslJvmModelInferrer.this._typeReferenceBuilder.typeRef(Iterator.class, HDslJvmModelInferrer.this._typeReferenceBuilder.typeRef(_builder.toString())));
            HDslJvmModelInferrer.this._jvmTypesBuilder.<JvmFormalParameter>operator_add(_parameters, _parameter);
            EList<JvmFormalParameter> _parameters_1 = it.getParameters();
            JvmFormalParameter _parameter_1 = HDslJvmModelInferrer.this._jvmTypesBuilder.toParameter(element, "collector", HDslJvmModelInferrer.this._typeReferenceBuilder.typeRef(Collector.class, HDslJvmModelInferrer.this._typeReferenceBuilder.typeRef(HenkanRow.class)));
            HDslJvmModelInferrer.this._jvmTypesBuilder.<JvmFormalParameter>operator_add(_parameters_1, _parameter_1);
            HDslJvmModelInferrer.this._jvmTypesBuilder.setBody(it, element);
          }
        };
        JvmOperation _method = HDslJvmModelInferrer.this._jvmTypesBuilder.toMethod(element, "main", HDslJvmModelInferrer.this._typeReferenceBuilder.typeRef(Void.TYPE), _function);
        HDslJvmModelInferrer.this._jvmTypesBuilder.<JvmOperation>operator_add(_members, _method);
      }
    };
    acceptor.<JvmGenericType>accept(this._jvmTypesBuilder.toClass(element, _builder.toString()), _function);
    EList<EObject> _eContents = element.eContents();
    for (final EObject child : _eContents) {
      this.infer(child, acceptor, isPreIndexingPhase);
    }
  }
  
  protected void _infer(final SourceDescription source, final IJvmDeclaredTypeAcceptor acceptor, final boolean isPreIndexingPhase) {
    final Integer sourceID = Integer.valueOf(source.getId());
    final List<ColumnInfo> columns = this.repo.load((sourceID).intValue());
    StringConcatenation _builder = new StringConcatenation();
    String _name = source.getName();
    _builder.append(_name);
    _builder.append("Row");
    final Procedure1<JvmGenericType> _function = new Procedure1<JvmGenericType>() {
      public void apply(final JvmGenericType it) {
        EList<JvmTypeReference> _superTypes = it.getSuperTypes();
        JvmTypeReference _typeRef = HDslJvmModelInferrer.this._typeReferenceBuilder.typeRef(HenkanRow.class);
        HDslJvmModelInferrer.this._jvmTypesBuilder.<JvmTypeReference>operator_add(_superTypes, _typeRef);
        for (final ColumnInfo a : columns) {
          {
            final JvmField field = HDslJvmModelInferrer.this._jvmTypesBuilder.toField(source, a.columnName, HDslJvmModelInferrer.this._typeReferenceBuilder.typeRef(a.columnType));
            field.setVisibility(JvmVisibility.PUBLIC);
            EList<JvmMember> _members = it.getMembers();
            HDslJvmModelInferrer.this._jvmTypesBuilder.<JvmField>operator_add(_members, field);
          }
        }
      }
    };
    acceptor.<JvmGenericType>accept(this._jvmTypesBuilder.toClass(source, _builder.toString()), _function);
  }
  
  protected void _infer(final EmitExpression emit, final IJvmDeclaredTypeAcceptor acceptor, final boolean isPreIndexingPhase) {
    final OperatorDescription operator = HDslJvmModelInferrer.getOperator(emit);
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("emit column count:");
    int _size = emit.getColumns().size();
    _builder.append(_size);
    _builder.append(" operator name ");
    String _name = operator.getName();
    _builder.append(_name);
    HDslJvmModelInferrer.LOG.info(_builder);
    StringConcatenation _builder_1 = new StringConcatenation();
    String _name_1 = operator.getName();
    _builder_1.append(_name_1);
    _builder_1.append("Row");
    final Procedure1<JvmGenericType> _function = new Procedure1<JvmGenericType>() {
      public void apply(final JvmGenericType it) {
        EList<JvmTypeReference> _superTypes = it.getSuperTypes();
        JvmTypeReference _typeRef = HDslJvmModelInferrer.this._typeReferenceBuilder.typeRef(HenkanRow.class);
        HDslJvmModelInferrer.this._jvmTypesBuilder.<JvmTypeReference>operator_add(_superTypes, _typeRef);
        if ((!isPreIndexingPhase)) {
          EList<XExpression> _columns = emit.getColumns();
          for (final XExpression c : _columns) {
            if ((c instanceof ExpressionColumn)) {
              String _xifexpression = null;
              String _name = ((ExpressionColumn)c).getName();
              boolean _tripleNotEquals = (_name != null);
              if (_tripleNotEquals) {
                _xifexpression = ((ExpressionColumn)c).getName();
              } else {
                XExpression _xpr = ((ExpressionColumn)c).getXpr();
                _xifexpression = ((XAbstractFeatureCall) _xpr).getFeature().getSimpleName();
              }
              final String name = _xifexpression;
              StringConcatenation _builder = new StringConcatenation();
              _builder.append("operator name ");
              String _name_1 = operator.getName();
              _builder.append(_name_1);
              _builder.append(" name:");
              _builder.append(name);
              HDslJvmModelInferrer.LOG.info(_builder);
              final JvmTypeReference inferred = HDslJvmModelInferrer.this._jvmTypesBuilder.inferredType(((ExpressionColumn)c).getXpr());
              final JvmField field = HDslJvmModelInferrer.this._jvmTypesBuilder.toField(((ExpressionColumn)c).getXpr(), name, inferred);
              field.setVisibility(JvmVisibility.PUBLIC);
              EList<JvmMember> _members = it.getMembers();
              HDslJvmModelInferrer.this._jvmTypesBuilder.<JvmField>operator_add(_members, field);
            } else {
              final Pattern p = Pattern.compile(((RegExColumn) c).getRegex());
              StringConcatenation _builder_1 = new StringConcatenation();
              String _name_2 = operator.getSource().getName();
              _builder_1.append(_name_2);
              _builder_1.append("Row");
              JvmTypeReference _typeRef_1 = HDslJvmModelInferrer.this._typeReferenceBuilder.typeRef(_builder_1.toString());
              final Function1<JvmField, Tuple2<String, JvmField>> _function = new Function1<JvmField, Tuple2<String, JvmField>>() {
                public Tuple2<String, JvmField> apply(final JvmField it) {
                  String _simpleName = it.getSimpleName();
                  return new Tuple2<String, JvmField>(_simpleName, it);
                }
              };
              final Function1<Tuple2<String, JvmField>, Boolean> _function_1 = new Function1<Tuple2<String, JvmField>, Boolean>() {
                public Boolean apply(final Tuple2<String, JvmField> it) {
                  return Boolean.valueOf(p.matcher(it.getFirst()).matches());
                }
              };
              final Function1<Tuple2<String, JvmField>, JvmField> _function_2 = new Function1<Tuple2<String, JvmField>, JvmField>() {
                public JvmField apply(final Tuple2<String, JvmField> it) {
                  return HDslJvmModelInferrer.this._jvmTypesBuilder.toField(c, it.getFirst(), it.getSecond().getType());
                }
              };
              final Iterable<JvmField> filteredMembers = IterableExtensions.<Tuple2<String, JvmField>, JvmField>map(IterableExtensions.<Tuple2<String, JvmField>>filter(IterableExtensions.<JvmField, Tuple2<String, JvmField>>map(((JvmDeclaredType) _typeRef_1).getDeclaredFields(), _function), _function_1), _function_2);
              EList<JvmMember> _members_1 = it.getMembers();
              HDslJvmModelInferrer.this._jvmTypesBuilder.<JvmMember>operator_add(_members_1, filteredMembers);
            }
          }
        }
      }
    };
    acceptor.<JvmGenericType>accept(this._jvmTypesBuilder.toClass(emit, _builder_1.toString()), _function);
  }
  
  public static OperatorDescription getOperator(final XExpression element) {
    EObject current = element.eContainer();
    while (((current != null) && (!(current instanceof OperatorDescription)))) {
      current = current.eContainer();
    }
    return ((OperatorDescription) current);
  }
  
  public JvmField myToFiedfdld(final EObject sourceElement, final String name, final JvmTypeReference typeRef) {
    if (((sourceElement == null) || (name == null))) {
      return null;
    }
    final JvmField result = this.typesFactory.createJvmField();
    result.setSimpleName(name);
    result.setVisibility(JvmVisibility.PUBLIC);
    result.setType(this._jvmTypesBuilder.cloneWithProxies(typeRef));
    this._jvmTypesBuilder.<JvmField>associate(sourceElement, result);
    return result;
  }
  
  public void infer(final EObject element, final IJvmDeclaredTypeAcceptor acceptor, final boolean isPreIndexingPhase) {
    if (element instanceof HenkanClosure) {
      _infer((HenkanClosure)element, acceptor, isPreIndexingPhase);
      return;
    } else if (element instanceof EmitExpression) {
      _infer((EmitExpression)element, acceptor, isPreIndexingPhase);
      return;
    } else if (element instanceof SourceDescription) {
      _infer((SourceDescription)element, acceptor, isPreIndexingPhase);
      return;
    } else if (element != null) {
      _infer(element, acceptor, isPreIndexingPhase);
      return;
    } else {
      throw new IllegalArgumentException("Unhandled parameter types: " +
        Arrays.<Object>asList(element, acceptor, isPreIndexingPhase).toString());
    }
  }
  
  private final static Logger LOG = Logger.getLogger(HDslJvmModelInferrer.class);
}
