package henkan.dsl.jvmmodel;

import henkan.dsl.hDsl.EmitExpression;
import henkan.dsl.hDsl.ExpressionColumn;
import henkan.dsl.jvmmodel.HDslJvmModelInferrer;
import org.apache.log4j.Logger;
import org.eclipse.emf.common.util.EList;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.eclipse.xtext.util.internal.Log;
import org.eclipse.xtext.xbase.XExpression;
import org.eclipse.xtext.xbase.compiler.XbaseCompiler;
import org.eclipse.xtext.xbase.compiler.output.ITreeAppendable;

@Log
@SuppressWarnings("all")
public class HenkanCompiler extends XbaseCompiler {
  protected void doInternalToJavaStatement(final XExpression obj, final ITreeAppendable a, final boolean isReferenced) {
    if ((obj instanceof EmitExpression)) {
      HenkanCompiler.LOG.info("compilation is in progress");
      final String varName = a.declareSyntheticVariable(obj, "_row");
      a.newLine();
      StringConcatenation _builder = new StringConcatenation();
      String _name = HDslJvmModelInferrer.getOperator(obj).getName();
      _builder.append(_name);
      _builder.append("Row");
      ITreeAppendable _append = a.append(_builder).append(" ").append(varName);
      StringConcatenation _builder_1 = new StringConcatenation();
      _builder_1.append(" ");
      _builder_1.append("= new ");
      String _name_1 = HDslJvmModelInferrer.getOperator(obj).getName();
      _builder_1.append(_name_1, " ");
      _builder_1.append("Row();");
      _append.append(_builder_1).newLine();
      EList<XExpression> _columns = ((EmitExpression)obj).getColumns();
      for (final XExpression c : _columns) {
        if ((c instanceof ExpressionColumn)) {
          this.internalToJavaStatement(((ExpressionColumn)c).getXpr(), a, true);
          StringConcatenation _builder_2 = new StringConcatenation();
          _builder_2.append(varName);
          _builder_2.append(".");
          String _name_2 = ((ExpressionColumn)c).getName();
          _builder_2.append(_name_2);
          _builder_2.append(" = ");
          a.append(_builder_2);
          this.internalToJavaExpression(((ExpressionColumn)c).getXpr(), a);
          a.append(";").newLine();
        }
      }
      StringConcatenation _builder_3 = new StringConcatenation();
      _builder_3.append("collector.out(");
      _builder_3.append(varName);
      _builder_3.append(");");
      a.append(_builder_3).newLine();
    } else {
      super.doInternalToJavaStatement(obj, a, isReferenced);
    }
  }
  
  protected boolean internalCanCompileToJavaExpression(final XExpression e, final ITreeAppendable a) {
    boolean _xifexpression = false;
    if ((e instanceof EmitExpression)) {
      return false;
    } else {
      _xifexpression = super.internalCanCompileToJavaExpression(e, a);
    }
    return _xifexpression;
  }
  
  private final static Logger LOG = Logger.getLogger(HenkanCompiler.class);
}
