package henkan.dsl.lib;

import org.eclipse.xtend.lib.annotations.Data;
import org.eclipse.xtext.xbase.lib.Pure;
import org.eclipse.xtext.xbase.lib.util.ToStringBuilder;

@Data
@SuppressWarnings("all")
public class Tuple2<A extends Object, B extends Object> {
  private final A first;
  
  private final B second;
  
  public Tuple2(final A first, final B second) {
    super();
    this.first = first;
    this.second = second;
  }
  
  @Override
  @Pure
  public int hashCode() {
    final int prime = 31;
    int result = 1;
    result = prime * result + ((this.first== null) ? 0 : this.first.hashCode());
    result = prime * result + ((this.second== null) ? 0 : this.second.hashCode());
    return result;
  }
  
  @Override
  @Pure
  public boolean equals(final Object obj) {
    if (this == obj)
      return true;
    if (obj == null)
      return false;
    if (getClass() != obj.getClass())
      return false;
    Tuple2<?, ?> other = (Tuple2<?, ?>) obj;
    if (this.first == null) {
      if (other.first != null)
        return false;
    } else if (!this.first.equals(other.first))
      return false;
    if (this.second == null) {
      if (other.second != null)
        return false;
    } else if (!this.second.equals(other.second))
      return false;
    return true;
  }
  
  @Override
  @Pure
  public String toString() {
    ToStringBuilder b = new ToStringBuilder(this);
    b.add("first", this.first);
    b.add("second", this.second);
    return b.toString();
  }
  
  @Pure
  public A getFirst() {
    return this.first;
  }
  
  @Pure
  public B getSecond() {
    return this.second;
  }
}
