package henkan.dsl.repo;

import org.eclipse.xtend.lib.annotations.Data;
import org.eclipse.xtext.xbase.lib.Pure;
import org.eclipse.xtext.xbase.lib.util.ToStringBuilder;

@Data
@SuppressWarnings("all")
public class ColumnInfo {
  public final String columnName;
  
  public final Class<?> columnType;
  
  public ColumnInfo(final String columnName, final Class<?> columnType) {
    super();
    this.columnName = columnName;
    this.columnType = columnType;
  }
  
  @Override
  @Pure
  public int hashCode() {
    final int prime = 31;
    int result = 1;
    result = prime * result + ((this.columnName== null) ? 0 : this.columnName.hashCode());
    result = prime * result + ((this.columnType== null) ? 0 : this.columnType.hashCode());
    return result;
  }
  
  @Override
  @Pure
  public boolean equals(final Object obj) {
    if (this == obj)
      return true;
    if (obj == null)
      return false;
    if (getClass() != obj.getClass())
      return false;
    ColumnInfo other = (ColumnInfo) obj;
    if (this.columnName == null) {
      if (other.columnName != null)
        return false;
    } else if (!this.columnName.equals(other.columnName))
      return false;
    if (this.columnType == null) {
      if (other.columnType != null)
        return false;
    } else if (!this.columnType.equals(other.columnType))
      return false;
    return true;
  }
  
  @Override
  @Pure
  public String toString() {
    ToStringBuilder b = new ToStringBuilder(this);
    b.add("columnName", this.columnName);
    b.add("columnType", this.columnType);
    return b.toString();
  }
  
  @Pure
  public String getColumnName() {
    return this.columnName;
  }
  
  @Pure
  public Class<?> getColumnType() {
    return this.columnType;
  }
}
