package henkan.dsl.repo;

import com.google.inject.BindingAnnotation;
import com.typesafe.config.Config;
import com.typesafe.config.ConfigFactory;
import com.typesafe.config.ConfigObject;
import henkan.dsl.repo.ColumnInfo;
import henkan.dsl.repo.SourceTypeRepo;
import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;
import java.util.List;
import javax.inject.Inject;
import org.apache.log4j.Logger;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.eclipse.xtext.util.internal.Log;
import org.eclipse.xtext.xbase.lib.Exceptions;
import org.eclipse.xtext.xbase.lib.Functions.Function1;
import org.eclipse.xtext.xbase.lib.IterableExtensions;
import org.eclipse.xtext.xbase.lib.ListExtensions;

@Log
@SuppressWarnings("all")
public class HoconSourceTypeRepo implements SourceTypeRepo {
  @Retention(RetentionPolicy.RUNTIME)
  @Target({ ElementType.FIELD, ElementType.PARAMETER })
  @BindingAnnotation
  public @interface HoconURL {
  }
  
  @Inject
  @HoconSourceTypeRepo.HoconURL
  private String config;
  
  public List<ColumnInfo> load(final int id) {
    List<ColumnInfo> _xblockexpression = null;
    {
      StringConcatenation _builder = new StringConcatenation();
      _builder.append("config path is ");
      _builder.append(this.config);
      _builder.append(" when id is ");
      _builder.append(id);
      HoconSourceTypeRepo.LOG.info(_builder);
      Config _load = ConfigFactory.load(this.config);
      StringConcatenation _builder_1 = new StringConcatenation();
      _builder_1.append("sources.");
      _builder_1.append(id);
      final ConfigObject sourceConfig = _load.getObject(_builder_1.toString());
      final Function1<String, ColumnInfo> _function = new Function1<String, ColumnInfo>() {
        public ColumnInfo apply(final String it) {
          try {
            Class<?> _forName = Class.forName(sourceConfig.get(it).unwrapped().toString());
            return new ColumnInfo(it, _forName);
          } catch (Throwable _e) {
            throw Exceptions.sneakyThrow(_e);
          }
        }
      };
      _xblockexpression = ListExtensions.<String, ColumnInfo>map(IterableExtensions.<String>toList(sourceConfig.keySet()), _function);
    }
    return _xblockexpression;
  }
  
  private final static Logger LOG = Logger.getLogger(HoconSourceTypeRepo.class);
}
