/**
 * generated by Xtext 2.11.0
 */
package henkan.dsl.validation;

import henkan.dsl.hDsl.EmitExpression;
import henkan.dsl.hDsl.HDslPackage;
import henkan.dsl.hDsl.HenkanFlowDescription;
import henkan.dsl.hDsl.HenkanNodeDescription;
import henkan.dsl.hDsl.OperatorDescription;
import henkan.dsl.hDsl.SinkDescription;
import henkan.dsl.hDsl.SourceDescription;
import henkan.dsl.validation.AbstractHDslValidator;
import java.util.HashSet;
import java.util.Set;
import org.apache.log4j.Logger;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.util.internal.Log;
import org.eclipse.xtext.validation.Check;
import org.eclipse.xtext.xbase.XExpression;
import org.eclipse.xtext.xbase.lib.CollectionLiterals;

/**
 * This class contains custom validation rules.
 * 
 * See https://www.eclipse.org/Xtext/documentation/303_runtime_concepts.html#validation
 */
@Log
@SuppressWarnings("all")
public class HDslValidator extends AbstractHDslValidator {
  @Check
  public void checkCycle(final HenkanNodeDescription node) {
    if ((node instanceof OperatorDescription)) {
      HDslValidator.LOG.info("operatordescription going to validate");
    }
    if ((node instanceof SourceDescription)) {
      return;
    }
    final HashSet<HenkanNodeDescription> visitedEntities = CollectionLiterals.<HenkanNodeDescription>newHashSet(node);
    HenkanNodeDescription current = null;
    current = this.getSource(node);
    while (((!(current instanceof SourceDescription)) && (current != null))) {
      {
        boolean _contains = visitedEntities.contains(current);
        if (_contains) {
          if ((node instanceof OperatorDescription)) {
            String _name = current.getName();
            String _plus = ("cycle in hierarchy of node \'" + _name);
            String _plus_1 = (_plus + "\'");
            this.error(_plus_1, 
              HDslPackage.eINSTANCE.getOperatorDescription_Source());
          } else {
            String _name_1 = current.getName();
            String _plus_2 = ("cycle in hierarchy of node \'" + _name_1);
            String _plus_3 = (_plus_2 + "\'");
            this.error(_plus_3, 
              HDslPackage.eINSTANCE.getSinkDescription_Source());
          }
          return;
        }
        visitedEntities.add(current);
        current = this.getSource(current);
      }
    }
  }
  
  protected HenkanNodeDescription getSource(final HenkanNodeDescription node) {
    HenkanNodeDescription _xifexpression = null;
    if ((node instanceof OperatorDescription)) {
      _xifexpression = ((OperatorDescription)node).getSource();
    } else {
      HenkanNodeDescription _xifexpression_1 = null;
      if ((node instanceof SinkDescription)) {
        _xifexpression_1 = ((SinkDescription)node).getSource();
      }
      _xifexpression = _xifexpression_1;
    }
    return _xifexpression;
  }
  
  @Check
  public void checkNames(final HenkanNodeDescription node) {
    EObject _eContainer = node.eContainer();
    HenkanFlowDescription flow = ((HenkanFlowDescription) _eContainer);
    final Set<String> names = CollectionLiterals.<String>newHashSet();
    EList<HenkanNodeDescription> _descriptions = flow.getDescriptions();
    for (final HenkanNodeDescription desc : _descriptions) {
      {
        boolean _contains = names.contains(desc.getName().toLowerCase());
        if (_contains) {
          String _name = desc.getName();
          String _plus = ("duplicate node name of node \'" + _name);
          String _plus_1 = (_plus + "\'");
          this.error(_plus_1, 
            HDslPackage.eINSTANCE.getHenkanNodeDescription_Name());
        }
        names.add(desc.getName().toLowerCase());
      }
    }
  }
  
  @Check
  public void checkSource(final HenkanNodeDescription node) {
    if ((node instanceof SourceDescription)) {
      return;
    }
    HenkanNodeDescription current = null;
    HenkanNodeDescription _xifexpression = null;
    if ((node instanceof OperatorDescription)) {
      _xifexpression = ((OperatorDescription)node).getSource();
    } else {
      HenkanNodeDescription _xifexpression_1 = null;
      if ((node instanceof SinkDescription)) {
        _xifexpression_1 = ((SinkDescription)node).getSource();
      }
      _xifexpression = _xifexpression_1;
    }
    current = _xifexpression;
    if ((current instanceof SinkDescription)) {
      if ((node instanceof OperatorDescription)) {
        String _name = ((SinkDescription)current).getName();
        String _plus = ("typeless node for source of node \'" + _name);
        String _plus_1 = (_plus + "\'");
        this.error(_plus_1, 
          HDslPackage.eINSTANCE.getOperatorDescription_Source());
      } else {
        String _name_1 = ((SinkDescription)current).getName();
        String _plus_2 = ("typeless node for source of node \'" + _name_1);
        String _plus_3 = (_plus_2 + "\'");
        this.error(_plus_3, 
          HDslPackage.eINSTANCE.getSinkDescription_Source());
      }
    }
  }
  
  public boolean isValueExpectedRecursive(final XExpression expr) {
    return ((expr.eContainer() instanceof EmitExpression) || super.isValueExpectedRecursive(expr));
  }
  
  private final static Logger LOG = Logger.getLogger(HDslValidator.class);
}
