package henkan.dsl.tests;

import com.google.inject.Inject;
import henkan.dsl.repo.ColumnInfo;
import henkan.dsl.repo.HoconSourceTypeRepo;
import henkan.dsl.repo.SourceTypeRepo;
import henkan.dsl.tests.HDslInjectorProvider;
import java.util.List;
import java.util.function.Consumer;
import org.eclipse.xtext.testing.InjectWith;
import org.eclipse.xtext.testing.XtextRunner;
import org.eclipse.xtext.xbase.lib.InputOutput;
import org.eclipse.xtext.xbase.lib.StringExtensions;
import org.junit.Assert;
import org.junit.Test;
import org.junit.runner.RunWith;

@RunWith(XtextRunner.class)
@InjectWith(HDslInjectorProvider.class)
@SuppressWarnings("all")
public class HoconConfigTest {
  @Inject
  private SourceTypeRepo repo;
  
  @Inject
  @HoconSourceTypeRepo.HoconURL
  private String repourl;
  
  @Test
  public void repoPath() {
    Assert.assertFalse(StringExtensions.isNullOrEmpty(this.repourl));
  }
  
  @Test
  public void repoLoad() {
    final List<ColumnInfo> result = this.repo.load(1);
    final Consumer<ColumnInfo> _function = new Consumer<ColumnInfo>() {
      public void accept(final ColumnInfo it) {
        InputOutput.<ColumnInfo>println(it);
      }
    };
    result.forEach(_function);
  }
}
