'use strict';
Object.defineProperty(exports, "__esModule", { value: true });
const vscode_jsonrpc_1 = require("vscode-jsonrpc");
const vscode_1 = require("vscode");
const vscode_languageclient_1 = require("vscode-languageclient");
function activate(context) {
    // The server is a started as a separate app and listens on port 5007
    var websocket = require("websocket-stream");
    let connectionInfo = {
        port: 4389,
        host: "localhost"
    };
    let serverOptions = () => {
        // Connect to language server via socket
        console.log("preparing connection");
        let socket = websocket("ws://localhost:4389");
        let result = {
            writer: socket,
            reader: socket
        };
        console.log("connection established");
        return Promise.resolve(result);
    };
    let clientOptions = {
        documentSelector: ['hdsl'],
        synchronize: {
            configurationSection: 'hdslserver',
            fileEvents: vscode_1.workspace.createFileSystemWatcher('**/*.hl')
        },
        revealOutputChannelOn: vscode_languageclient_1.RevealOutputChannelOn.Info,
        errorHandler: {
            error: (e, m, c) => {
                console.log(`error:${e} message:${m} count:${c}`);
                //console.log(`got error`)
                return vscode_languageclient_1.ErrorAction.Continue;
            },
            closed: () => vscode_languageclient_1.CloseAction.DoNotRestart
        },
        initializationFailedHandler: () => { return false; }
    };
    // Create the language client and start the client.
    let lc = new vscode_languageclient_1.LanguageClient('HDSLLanguageServer', 'HDsl Language Server', serverOptions, clientOptions);
    // enable tracing (.Off, .Messages, Verbose)
    lc.trace = vscode_jsonrpc_1.Trace.Verbose;
    let disposable = lc.start();
    console.log("calling subscription pushh");
    // Push the disposable to the context's subscriptions so that the 
    // client can be deactivated on extension deactivation
    context.subscriptions.push(disposable);
}
exports.activate = activate;
//# sourceMappingURL=extension.js.map